Index: app/models/setting.rb
===================================================================
--- app/models/setting.rb	(revision 5548)
+++ app/models/setting.rb	(working copy)
@@ -%ld,%ld +%ld,%ld @@
   validates_inclusion_of :name, :in => @@available_settings.keys
   validates_numericality_of :value, :only_integer => true, :if => Proc.new { |setting| @@available_settings[setting.name]['format'] == 'int' }  
 
-  # Hash used to cache setting values
-  @cached_settings = {}
-  @cached_cleared_on = Time.now
-  
   def value
     v = read_attribute(:value)
     # Unserialize serialized settings
@@ -%ld,%ld +%ld,%ld @@
   
   # Returns the value of the setting named name
   def self.[](name)
-    v = @cached_settings[name]
-    v ? v : (@cached_settings[name] = find_or_default(name).value)
+    Rails.cache.fetch("redmine-settings/#{name}") { find_or_default(name).value }
   end
   
   def self.[]=(name, v)
     setting = find_or_default(name)
     setting.value = (v ? v : "")
-    @cached_settings[name] = nil
+    Rails.cache.delete "redmine-settings/#{name}"
     setting.save
     setting.value
   end
@@ -%ld,%ld +%ld,%ld @@
   # Called once per request
   def self.check_cache
     settings_updated_on = Setting.maximum(:updated_on)
-    if settings_updated_on && @cached_cleared_on <= settings_updated_on
-      @cached_settings.clear
-      @cached_cleared_on = Time.now
+    if settings_updated_on && (Rails.cache.read('redmine-settings-cleared-on')||Time.now) <= settings_updated_on
+      Rails.cache.delete_matched( /^redmine-settings\/.+$/ )
+      Rails.cache.write('redmine-settings-cleared-on', Time.now)
       logger.info "Settings cache cleared." if logger
     end
   end
